
#include <stderror.mqh>
#include <stdlib.mqh>

extern double     StopLoss       =  3; 
extern double  TrSt           =  1.8;
extern double  trailingStep =0;
extern double  pip = 0.00004;
extern bool    stop = true ;
extern double  D=2;
extern double  Speed          =  3;
extern double  timeSpeed      =  0; 
extern double Lot = 0.1;
extern double MARGIN =0.3;
extern int SPREAD =17;
extern int market = 1;
extern int Magic = 5555;
extern int  PipMultiplier=10;


double         Point_;
datetime       nextTime;
int            cnt, total, lastBars,i;
int            up, down, TimeSpeedUp, TimeSpeedDown;
bool           TimBoolUp,TimBoolDown, OrderSal;
double         priceUp, priceDown,profit,eee,Lotti=0,lots=0,MG,Min_Lot,Max_Lot;
datetime time;
int m,db=0,ds=0;

int start()
{  
   //.........................................................
        Max_Lot = MarketInfo(Symbol(), MODE_MAXLOT);
        Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);
        MG=AccountFreeMargin();
        m=MG/MarketInfo (Symbol(), MODE_MARGINREQUIRED)*MARGIN/Min_Lot;               
 //.....................................................   
   for (int q = 0; q < OrdersTotal(); q++)   
   {
      OrderSelect(q, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()&&OrderMagicNumber()==Magic)
      {
       if (OrderType() == OP_BUY&&OrderStopLoss()<OrderOpenPrice()&&Bid<=OrderStopLoss()+Point)PlaySound("stops.wav");
       if (OrderType() == OP_SELL&&OrderStopLoss()>OrderOpenPrice()&&Ask>=OrderStopLoss()-Point)PlaySound("stops.wav");
       if (OrderType() == OP_BUY&&OrderStopLoss()>OrderOpenPrice())ds=1;
       if (OrderType() == OP_SELL&&OrderStopLoss()<OrderOpenPrice())db=1;


      {

         if (Bid-OrderOpenPrice()>TrSt*Point*PipMultiplier)
         {
            if (OrderStopLoss()<Bid-(TrSt+ trailingStep )*Point*PipMultiplier )
            {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid - TrSt*Point*PipMultiplier,0, 0,CLR_NONE);
              PlaySound("ok.wav");
            }
         }        
      }
      if (OrderType() == OP_SELL)
      {   
     
         if (OrderOpenPrice()-Ask > TrSt*Point*PipMultiplier)
         {
           if (OrderStopLoss() > Ask +(TrSt+ trailingStep )*Point*PipMultiplier ) 
           {
              OrderModify(OrderTicket(),OrderOpenPrice(),Ask + TrSt*Point*PipMultiplier,0, 0,CLR_NONE);
              PlaySound("ok.wav");
           }
         }            
      }
    //  return(0);
      }
   }
   
   double ask = Ask;//-pip*Point;   
   double bid = Bid;//+pip*Point;
   
   total = OrdersTotal();
   int   i, currentSymbolOrderPos = -1;
      
   for (i = 0; i < total; i++)   
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()&&OrderMagicNumber()==Magic)
      {
       if (OrderType() == OP_BUYSTOP&&ds==1)OrderDelete(OrderTicket(),CLR_NONE);
       if (OrderType() == OP_SELLSTOP&&db==1)OrderDelete(OrderTicket(),CLR_NONE);
         currentSymbolOrderPos = i;
         break;
      }
   }
   
   if (Lot>0)
   {      
      if(priceUp < bid)//
      {
         up = up + D;
         priceUp = bid+pip;//
         if(TimBoolUp == false)
         {
            TimeSpeedUp = TimeCurrent();
            TimBoolUp = true;
         }   
      }
   else
      {
        priceUp = 0;
       
        up      = 0;
        TimBoolUp = false;
        TimeSpeedUp = 0;
      }
   
      if(priceDown > ask)
      {
         down = down + D;
         priceDown = ask-pip;
         if(TimBoolDown == false)
         {
            TimeSpeedDown = TimeCurrent();
            TimBoolDown = true;
         }   
      }
      else
      {
         priceDown = 0;
         down      = 0;
         TimBoolDown = false;
         TimeSpeedDown = 0;   
      }
 
      if(up >= Speed || down >= Speed)
      {          
       if(SPREAD<MarketInfo(Symbol(), MODE_SPREAD))return(0);
   int try;
   double s;
   if(up < down)
   {
          if(TimeCurrent() - TimeSpeedDown <= timeSpeed&&OrderType()!=OP_SELL)
      {           
         RefreshRates(); 
         for(try = 1; try <= 2; try++)
         {   
           
           if(market > 0 )s = Ask+StopLoss*Point*PipMultiplier;
           if(market == 0 )s = 0;
           if(MARGIN==0)Lotti= Lot;
           if(MARGIN>0)Lotti = m*Min_Lot;
           if(Lotti < Min_Lot)Lotti=Min_Lot;
           if(Lotti > Max_Lot)Lotti=Max_Lot;
           OrderSend(Symbol(),OP_SELL,Lotti,Bid,10,s,0 ,"",Magic,0,Red);
           if(stop==true)OrderSend(Symbol(),OP_BUYSTOP,2*Lotti,s,10,Bid,0 ,"",Magic,TimeCurrent()+660,Aqua);
           PlaySound("alert.wav");//Alert("M3 SELL");
           return(0);              
         }
      }   
   }
    else 
   {  
          if(TimeCurrent() - TimeSpeedUp <= timeSpeed&&OrderType()!=OP_BUY)
      {           
           RefreshRates();    
         for(try = 1; try <= 2; try++)//lots
         {  
            
            if(market > 0 )s = Bid-StopLoss*Point*PipMultiplier;
            if(market == 0 )s = 0;            
            if(MARGIN==0)Lotti= Lot;
            if(MARGIN>0)Lotti = m*Min_Lot;  
            if(Lotti < Min_Lot)Lotti=Min_Lot; 
            if(Lotti > Max_Lot)Lotti=Max_Lot;    
            OrderSend(Symbol(),OP_BUY,Lotti,Ask,10,s,0, "", Magic, 0, Aqua);
            if(stop==true)OrderSend(Symbol(),OP_SELLSTOP,2*Lotti,s,10,Ask,0 ,"",Magic,TimeCurrent()+660,Red);
            PlaySound("alert2.wav");//Alert("M3 BUY");
            return(0);
              
         }
                
      }   
   }    
   priceUp   = 0;
   priceDown = 0;
   up        = 0;
   down      = 0;
   TimBoolUp = false;
   TimBoolDown = false;
   TimeSpeedUp = 0;
   TimeSpeedDown = 0;                              
      }   
   
         
      if(priceUp == 0)
      {
         priceUp   =bid+pip;         
      }
      if(priceDown == 0)
      {        
         priceDown = ask-pip;
      }
   }   
else 
   {
      OrderSelect(currentSymbolOrderPos, SELECT_BY_POS, MODE_TRADES);
      
      if (OrderType() == OP_SELL&&OrderMagicNumber()==Magic && OrderProfit()>0 &&MarketInfo(Symbol(), MODE_STOPLEVEL)>TrSt*PipMultiplier)
      OrderClose (OrderTicket(),OrderLots(),Ask,5,CLR_NONE);  
      if (OrderType() == OP_BUY &&OrderMagicNumber()==Magic&& OrderProfit()>0 &&MarketInfo(Symbol(), MODE_STOPLEVEL) >TrSt*PipMultiplier)
      OrderClose (OrderTicket(),OrderLots(),Bid,5,CLR_NONE); 
      if (OrderType() == OP_SELL &&OrderStopLoss()==0&&OrderMagicNumber()==Magic)
      OrderModify(OrderTicket(),OrderOpenPrice(),Ask + StopLoss*Point*PipMultiplier,0, 0, CLR_NONE);
      if (OrderType() == OP_BUY  &&OrderStopLoss()==0&&OrderMagicNumber()==Magic)
      OrderModify(OrderTicket(),OrderOpenPrice(),Bid - StopLoss*Point*PipMultiplier,0, 0, CLR_NONE);
   }   
   return(0);
}

int init()
{

   return(0);
}

int deinit()
{
   return(0);
}





